-- written by DaddelZeit
-- DO NOT USE WITHOUT PERMISSION

local settingsFile = 'settings/zeit/syncRealToGameTime/settings.json'

local M = {}

local isEnabled = false
local tod = nil
local minutes = nil
local offSet = nil

local function getEnabled()
  return isEnabled
end

local function setEnabled(newVal)
	isEnabled = newVal
	jsonWriteFile(settingsFile, {isEnabled = newVal}, true)
end

local function onExtensionLoaded()
  if FS:fileExists(settingsFile) then
    local isEnabledRaw = readJsonFile(settingsFile)
    isEnabled = isEnabledRaw.isEnabled
  end
end

local function onGuiUpdate()
	if not isEnabled then return end

	tod = scenetree.tod
	if not tod then return end
	if not tod.play then tod.play = true end

	minutes = os.date("%H") * 60 + os.date("%M") + os.date("%S") / 60

	if minutes <= 720 then
		offSet = 0.5
	else
		offSet = -0.5
	end

	tod.time = minutes / 1440 + offSet
end

-- stuff called from the ui javascript
M.setEnabled = setEnabled
M.getEnabled = getEnabled

-- other stuff
M.onGuiUpdate = onGuiUpdate
M.onExtensionLoaded = onExtensionLoaded

return M
